/* gInfo - Copyright (C) 2004 bakunin - Andrea Marchesini 
 *                                      <bakunin@autistici.org>
 *
 * This source code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Public License as published 
 * by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * This source code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * Please refer to the GNU Public License for more details.
 *
 * You should have received a copy of the GNU Public License along with
 * this source code; if not, write to:
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef API_H
#define API_H

char plugin_text_api[] =
"La programmazione di moduli e' relativamente intuitiva se si sa programmare "
"in C. Sto pensando anche di inserire la possibilita' di scrivere moduli in "
"XML, ma nella versione attuale questo non e' ancora possibile.\n\n"
"gInfo carica i moduli presenti in una directory precisa. Questa la si puo' "
"sapere in base alla vostra installazione usando il programma "
"ginfo_config. Provate a lanciare il comando:\n\n"
"ginfo_config --help\n\n"
"Ogni volta che viene caricato un modulo, gInfo cerca la presenza di queste "
"funzioni:\n\n"
"int module_default(void); - Se esiste e se ritorna 1, vuol dire che questo e' "
"il modulo di default di gInfo. Il modulo di default e' il modulo principale, "
"ovvero quel modulo che viene mostrato all'apertura della finestra di tutor "
"anche se non lo si e' selezionato. Questo e' un modulo di default.\n"
"Puo' esistere solo un modulo di default ad avvio e se se ne trova piu' di "
"uno, solo il primo e' considerato tale.\n\n"
"char *module_name(void); - Il nome del modulo caricato. E' il nome mostrato "
"come titolo nella selezione degli argomenti.\n\n"
"int module_genre(void); - Definisce quale tipologia di modulo e' quello "
"caricato. Esistono varie tipologie. Leggete nel file ginfo_plugin.h\n\n"
"char **module_words(void); - L'elenco delle parole di ricerca possibili. "
"Quando l'utente effettua la ricerca di qualcosa, se una di queste parole, o "
"parte di queste sono legate ad un modulo, esso viene mostrato.\n\n"
"ginfo_tips *module_tooltips(int *); - Ritorna un array di elementi ginfo_tips "
"e inserisce nell'int passato il numero di elementi inviati. Questi tips sono "
"i suggerimenti che poi ginfo utilizzera'. Ogni tips e' composto da un testo "
"e da una funzione. Se non si mette la funzione, alla risposta affermativa "
"dell'utente su maggiori informazioni, gInfo mostrera' la schermata iniziale "
"del modulo, altrimenti, verra' utilizzata la funzione apposita specificata."
"\n\n"
"ginfo_docs *module_docs(int *); - Funziona esattamente come module_tooltips() "
"e fornisce la documentazione da mostrare. La documentazione e' composta da "
"un titolo e da una funzione di visualizzazione. Entrambi gli elementi sono "
"obligatori.\n\n";

char plugin_text_api_utils[] =
"Esistono due funzioni di utilita':\n\n"
"void ginfo_error(char *); - per segnalare un errore irreversibile che deve "
"causare l'uscita del programma. Nel char * si deve inserire la spiegazione.\n\n"
"GtkWidget *ginfo_window(void); - ritorna al modulo l'oggetto finestra. Non si "
"deve attaccare qualcosa a questo oggetto perche' provocherebbe l'instabilita' "
"del software intero. Puo' essere utile per sapere, grandezza, colori e altro "
"della finestra principale.\n\n";

char plugin_text_api_easy[] =
"Per semplificare la creazione delle strutture dati per le funzioni module_tooltips e module_docs, esistono delle utility che qui vado ad elencare:\n\n"
"void *ginfo_easy_docs_init(void); - La si lancia quando si vuole creare "
"l'elenco della documentazione. Ritorna un void * che va passato a tutte le "
"altre funzioni spiegate qui di seguito.\n\n"
"int ginfo_easy_docs_add(void *, char *, GtkWidget *(*)(void *), void *); - "
"Aggiunge una sezione alla documentazione legata al modulo. Il primo argomento "
"e' il void * ottenuto dalla funzione precedente; il secondo e' il nome della "
"documentazione; il terzo e' la funzione di visualizzazione; il quarto un "
"eventuale argomento da passare alla funzione di visualizzazione. Ritorna 1 "
"se ha fallito perche' non si e' passato niente come secondo o terzo "
"argomento.\n\n"
"ginfo_docs *ginfo_easy_docs_close(void *, int *); - ritorna la struttura da "
"inviare come valore di ritorno alla funzione module_docs. Il primo argomento "
"e' sempre il void * della funzione di init, il secondo e' l'argomento int * "
"che viene ricevuto dalla funzione module_docs.Puo' ritornare NULL se non "
"si sono inseriti elementi nella struttura di documentazione.\n\n"
"Esattamente uguali sono le funzioni:\n\n"
"void *ginfo_easy_tips_init(void);\n\n"
"int ginfo_easy_tips_add(void *, char *, GtkWidget *(*)(void *), void *);\n\n"
"ginfo_tips *ginfo_easy_tips_close(void *, int *);\n\n";

#endif
